use crate::storage_manager::StorageManagerConfig;
use config::Config;
use serde::{Deserialize, Serialize};
use std::path::PathBuf;

#[derive(Debug, Clone, Serialize, Deserialize)]
pub struct PicOxConfig {
    pub host: String,
    pub db_path: PathBuf,

    pub storage_config: StorageManagerConfig,
}

impl PicOxConfig {
    pub fn new(config: PathBuf) -> PicOxConfig {
        let pic_ox_config = Config::builder()
            .add_source(config::File::new(
                config.to_str().unwrap(),
                config::FileFormat::Toml,
            ))
            .build()
            .unwrap();

        pic_ox_config.try_deserialize().unwrap()
    }
}
